summaryrefslogtreecommitdiffstats
path: root/utils
diff options
context:
space:
mode:
Diffstat (limited to 'utils')
-rwxr-xr-xutils/docs-build.sh234
-rwxr-xr-x[-rw-r--r--]utils/gpg_import_key.sh32
-rw-r--r--utils/test/result_collection_api/update/README.md158
-rw-r--r--utils/test/result_collection_api/update/templates/__init__.py0
-rw-r--r--utils/test/result_collection_api/update/templates/backup_mongodb.py (renamed from utils/test/result_collection_api/update/backup.py)2
-rw-r--r--utils/test/result_collection_api/update/templates/changes_in_mongodb.py (renamed from utils/test/result_collection_api/update/changes.py)0
-rw-r--r--utils/test/result_collection_api/update/templates/restore_mongodb.py (renamed from utils/test/result_collection_api/update/restore.py)0
-rw-r--r--utils/test/result_collection_api/update/templates/rm_olds.sh15
-rw-r--r--utils/test/result_collection_api/update/templates/update_mongodb.py (renamed from utils/test/result_collection_api/update/update.py)2
-rw-r--r--utils/test/result_collection_api/update/templates/utils.py (renamed from utils/test/result_collection_api/update/utils.py)0
-rw-r--r--utils/test/result_collection_api/update/update.yml41
11 files changed, 185 insertions, 299 deletions
diff --git a/utils/docs-build.sh b/utils/docs-build.sh
deleted file mode 100755
index 48037db2e..000000000
--- a/utils/docs-build.sh
+++ /dev/null
@@ -1,234 +0,0 @@
-#!/bin/bash -e
-# SPDX-license-identifier: Apache-2.0
-##############################################################################
-# Copyright (c) 2016 NEC and others.
-# All rights reserved. This program and the accompanying materials
-# are made available under the terms of the Apache License, Version 2.0
-# which accompanies this distribution, and is available at
-# http://www.apache.org/licenses/LICENSE-2.0
-##############################################################################
-export PATH=$PATH:/usr/local/bin/
-
-DOCS_DIR=${DOCS_DIR:-docs}
-INDEX_RST=${INDEX_RST:-index.rst}
-BUILD_DIR=${BUILD_DIR:-docs_build}
-OUTPUT_DIR=${OUTPUT_DIR:-docs_output}
-SRC_DIR=${SRC_DIR:-$BUILD_DIR/_src}
-VENV_DIR=${VENV_DIR:-$BUILD_DIR/_venv}
-RELENG_DIR=${RELENG_DIR:-releng}
-GERRIT_COMMENT=${GERRIT_COMMENT:-}
-
-get_title_script="
-import os
-from docutils import core, nodes
-
-try:
- with open('index.rst', 'r') as file:
- data = file.read()
- doctree = core.publish_doctree(data,
- settings_overrides={'report_level': 5,
- 'halt_level': 5})
- if isinstance(doctree[0], nodes.title):
- title = doctree[0]
- else:
- for c in doctree.children:
- if isinstance(c, nodes.section):
- title = c[0]
- break
- print title.astext()
-except:
- print 'None'"
-revision="$(git rev-parse --short HEAD)"
-rev_full="$(git rev-parse HEAD)"
-version="$(git describe --abbrev=0 2> /dev/null || echo draft) ($revision)"
-project="$(basename $(git rev-parse --show-toplevel))"
-html_notes=" Revision: $rev_full\n Build date: $(date -u +'%Y-%m-%d')"
-default_conf='releng/docs/etc/conf.py'
-opnfv_logo='releng/docs/etc/opnfv-logo.png'
-
-function check_rst_doc() {
- _src="$1"
-
- # Note: This check may fail in many jobs for building project docs, since
- # the old sample has lines more than 120. We ignore failures on this
- # check right now, but these have to be fixed before OPNFV B release.
- _out=$(doc8 --max-line-length 240 --ignore D000 "$_src") || {
- _msg='Warning: rst validation (doc8) has failed, please fix the following error(s).'
- _errs=$(echo "$_out" | sed -n -e "/^$_src/s/^/ /p")
- echo
- echo -e "$_msg\n$_errs"
- echo
- [[ -n "$GERRIT_COMMENT" ]] && echo -e "$_msg\n$_errs" >> "$GERRIT_COMMENT"
- }
-}
-
-function add_html_notes() {
- _src="$1"
-
- find "$_src" -name '*.rst' | while read file
- do
- if grep -q -e ' _sha1_' "$file" ; then
- # TODO: remove this, once old templates were removed from all repos.
- echo
- echo "Warn: '_sha1_' was found in [$file], use the latest document template."
- echo " See https://wiki.opnfv.org/documentation/tools ."
- echo
- sed -i "s/ _sha1_/ $git_sha1/g" "$file"
- fi
- sed -i -e "\$a\\\n..\n$html_notes" "$file"
- done
-}
-
-function prepare_src_files() {
- mkdir -p "$(dirname $SRC_DIR)"
-
- [[ -e "$SRC_DIR" ]] && rm -rf "$SRC_DIR"
- cp -r "$DOCS_DIR" "$SRC_DIR"
- add_html_notes "$SRC_DIR"
-}
-
-function add_config() {
- _conf="$1"
- _param="$2"
- _val="$3"
-
- if ! grep -q -e "^$_param = " "$_conf" ; then
- echo "Adding '$_param' into $_conf ..."
- echo "$_param = $_val" >> "$_conf"
- fi
-}
-
-function is_top_dir() {
- [[ "$1" == "$DOCS_DIR" ]]
-}
-
-function generate_name_for_top_dir() {
- for suffix in '' '.top' '.all' '.master' '_' '__' '___'
- do
- _name="$(basename $DOCS_DIR)$suffix"
- [[ -e "$DOCS_DIR/$_name" ]] && continue
- echo "$_name"
- return
- done
-
- echo "Error: cannot find name for top directory [$DOCS_DIR]"
- exit 1
-}
-
-function generate_name() {
- _dir=$1
-
- if is_top_dir "$_dir" ; then
- _name=$(generate_name_for_top_dir $DOCS_DIR)
- else
- _name="${_dir#$DOCS_DIR/}"
- fi
- # Replace '/' by '_'
- echo "${_name////_}"
-}
-
-
-check_rst_doc $DOCS_DIR
-
-if [[ ! -d "$RELENG_DIR" ]] ; then
- echo "Error: $RELENG_DIR dir not found. See https://wiki.opnfv.org/documentation/tools ."
- exit 1
-fi
-
-prepare_src_files
-
-if ! which virtualenv > /dev/null ; then
- echo "Error: 'virtualenv' not found. Exec 'sudo pip install virtualenv' first."
- exit 1
-fi
-
-virtualenv "$VENV_DIR"
-source "$VENV_DIR/bin/activate"
-pip install -r "$RELENG_DIR/docs/etc/requirements.txt"
-
-find $DOCS_DIR -name $INDEX_RST -printf '%h\n' | while read dir
-do
- name=$(generate_name $dir)
- if is_top_dir "$dir" ; then
- src="$SRC_DIR"
- else
- src="$SRC_DIR/${dir#$DOCS_DIR/}"
- fi
- build="$BUILD_DIR/$name"
- output="$OUTPUT_DIR/$name"
- conf="$src/conf.py"
-
- echo
- echo "#################${dir//?/#}"
- echo "Building DOCS in $dir"
- echo "#################${dir//?/#}"
- echo
-
- [[ ! -f "$conf" ]] && cp "$default_conf" "$conf"
- title=$(cd $src; python -c "$get_title_script")
- latex_conf="[('index', '$name.tex', \"$title\", 'OPNFV', 'manual'),]"
- add_config "$conf" 'latex_documents' "$latex_conf"
- add_config "$conf" 'release' "u'$version'"
- add_config "$conf" 'version' "u'$version'"
- add_config "$conf" 'project' "u'$project'"
- add_config "$conf" 'copyright' "u'$(date +%Y), OPNFV'"
- cp -f $opnfv_logo "$src/opnfv-logo.png"
-
- mkdir -p "$output"
-
- sphinx-build -b html -t html -E "$src" "$output"
-
- # Note: PDF creation may fail in project doc builds.
- # We allow this build job to be marked as succeeded with
- # failure in PDF creation, but leave message to fix it.
- # Any failure has to be fixed before OPNFV B release.
- {
- sphinx-build -b latex -t pdf -E "$src" "$build" && \
- make -C "$build" LATEXOPTS='--interaction=nonstopmode' all-pdf
- } && {
- mv "$build/$name.pdf" "$output"
- } || {
- msg="Error: PDF creation for $dir has failed, please fix source rst file(s)."
- echo
- echo "$msg"
- echo
- [[ -n "$GERRIT_COMMENT" ]] && echo "$msg" >> "$GERRIT_COMMENT"
- }
-
- # TODO: failures in ODT creation should be handled error and
- # cause 'exit 1' before OPNFV B release.
- tex=$(find $build -name '*.tex' | head -1)
- odt="${tex%.tex}.odt"
- if [[ -e $tex ]] && which pandoc > /dev/null ; then
- (
- cd $(dirname $tex)
- pandoc $(basename $tex) -o $(basename $odt)
- ) && {
- mv $odt $output/
- }|| {
- msg="Error: ODT creation for $dir has failed."
- echo
- echo "$msg"
- echo
- }
- else
- echo "Warn: tex file and/or 'pandoc' are not found, skip ODT creation."
- fi
-
- if is_top_dir "$dir" ; then
- # NOTE: Having top level document (docs/index.rst) is not recommended.
- # It may cause conflicts with other docs (mostly with HTML
- # folders for contents in top level docs and other document
- # folders). But, let's try merge of those contents into the top
- # docs directory.
- (
- cd $output
- find . -type d -print | xargs -I d mkdir -p ../d
- find . -type f -print | xargs -I f mv -b f ../f
- )
- rm -rf "$output"
- fi
-
-done
-
-deactivate
diff --git a/utils/gpg_import_key.sh b/utils/gpg_import_key.sh
index 3afeda839..bb11f0d45 100644..100755
--- a/utils/gpg_import_key.sh
+++ b/utils/gpg_import_key.sh
@@ -7,15 +7,32 @@
# which accompanies this distribution, and is available at
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################
-
function isinstalled {
-if rpm -q "$@" >/dev/null 2>&1; then
- true
- else
- echo installing "$1"
- sudo yum install "$1"
- false
+
+source /etc/os-release; echo ${ID/*, /}
+
+if [[ ${ID/*, /} =~ "centos" ]]; then
+ if rpm -q "$@" >/dev/null 2>&1; then
+ true
+ else
+ echo installing "$1"
+ sudo yum install "$1"
+ false
+ fi
+
+elif [[ ${ID/*, /} =~ "ubuntu" ]]; then
+ if dpkg-query -W -f'${Status}' "$@" 2>/dev/null | grep -q "ok installed"; then
+ true
+ else
+ echo installing "$1"
+ sudo apt-get install -y "$1"
+ false
+ fi
+else
+ echo "Distro not supported"
+ exit 0
fi
+
}
if ! isinstalled gnupg2; then
@@ -40,3 +57,4 @@ else
rm -f "$NODE_NAME"-subkey
fi
fi
+
diff --git a/utils/test/result_collection_api/update/README.md b/utils/test/result_collection_api/update/README.md
index 41b7fffa3..d3aef7efe 100644
--- a/utils/test/result_collection_api/update/README.md
+++ b/utils/test/result_collection_api/update/README.md
@@ -1,59 +1,105 @@
-# opnfv-testapi update
-
-## How to use:
-
-# backup mongodb,
-# arguments:
-# -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
-# -o/--output_dir: Output directory for the backup, default = ./
-# the backup output will be put under dir/db__XXXX_XX_XX_XXXXXX/db
-# -d/--db: database for the backup, default = test_results_collection
-```
-python backup.py
-```
-
-# restore mongodb
-# arguments:
-# -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
-# -i/--input_dir: Input directory for the Restore, must be specified
-# the restore input must be specified to dir/db__XXXX_XX_XX_XXXXXX/db
-# -d/--db: database name after the restore, default = basename of input_dir
-```
-python restore.py
-```
-
-# update mongodb
-# arguments:
-# -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
-# -d/--db: database name to be updated, default = test_results_collection
-# changes need to be done:
-# change collection name, modify changes.collections_old2New
-# collections_old2New = {
-# 'old_collection': 'new_collection',
-# }
-# change field name, modify changes.fields_old2New
-# fields_old2New = {
-# 'collection': [(query, {'old_field': 'new_field'})]
-# }
-# change the doc, modify changes.docs_old2New
-# docs_old2New = {
-# 'test_results': [
-# ({'field': 'old_value'}, {'field': 'new_value'}),
-# (query, {'field': 'new_value'}),
-# ]
-# }
-```
-python update.py
-```
-
-# update opnfv-testapi process
-# this script must be run right in this directory
-# and remember to change ../etc/config.ini before running this script
-# operations includes:
-# kill running test_collection_api & opnfv-testapi
-# install or update dependencies according to ../requirements.txt
-# install opnfv-testapi
-# run opnfv-testapi
+Welcome to TESTAPI Update!
+========================
+
+
+This file is used to describe how testapi update works
+
+----------
+How to use
+---------------
+
+#### <i class="icon-file"></i> backup mongodb
+
+arguments:
+: -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
+the backup output will be put under dir/db__XXXX_XX_XX_XXXXXX/db
+-d/--db: database for the backup, default = test_results_collection
+
+usage:
+```
+python backup_mongodb.py
+```
+
+#### <i class="icon-file"></i> restore mongodb
+
+arguments:
+: -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
+ -i/--input_dir: Input directory for the Restore, must be specified,
+ the restore input must be specified to dir/db__XXXX_XX_XX_XXXXXX/db
+ -d/--db: database name after the restore, default = basename of input_dir
+
+usage:
+```
+python restore_mongodb.py
+```
+#### <i class="icon-file"></i> update mongodb
+
+ arguments:
+: -u/--url: Mongo DB URL, default = mongodb://127.0.0.1:27017/
+ -d/--db: database name to be updated, default = test_results_collection
+
+changes need to be done:
+change collection name, modify changes.collections_old2New
+ > collections_old2New = {
+ 'old_collection': 'new_collection',
+ }
+
+ change field name, modify changes.fields_old2New
+ > fields_old2New = {
+ 'collection': [(query, {'old_field': 'new_field'})]
+ }
+
+ change the doc, modify changes.docs_old2New
+ > docs_old2New = {
+ 'test_results': [
+ ({'field': 'old_value'}, {'field': 'new_value'}),
+ (query, {'field': 'new_value'}),
+ ]
+ }
+
+#### <i class="icon-file"></i> update opnfv-testapi process
+This script must be run right in this directory and remember to
+change ../etc/config.ini before running this script.
+
+operations includes:
+: kill running test_collection_api & opnfv-testapi
+install or update dependencies according to ../requirements.txt
+install opnfv-testapi
+run opnfv-testapi
+
+usage:
```
python update_api.py
```
+#### <i class="icon-file"></i> update opnfv/testapi container
+Here ansible-playbook is used to implement auto update.
+Please make sure that the remote server is accessible via ssh.
+
+install ansible, please refer:
+```
+http://docs.ansible.com/ansible/intro_installation.html
+```
+run update.yml
+arguments:
+: host: remote server, must provide
+user: user used to access to remote server, default to root
+port: exposed port used to access to testapi, default to 8000
+image: testapi's docker image, default to opnfv/testapi:latest
+update_path: templates directory in remote server, default to /tmp/testapi
+mongodb_url: url of mongodb, default to 172.17.0.1, docker0 ip
+swagger_url: swagger access url, default to http://host:port
+
+usage:
+```
+ansible-playbook update.yml --extra-vars "
+host=10.63.243.17
+user=zte
+port=8000
+image=opnfv/testapi
+update_path=/tmp/testapi
+mongodb_url=mongodb://172.17.0.1:27017
+swagger_url=http://10.63.243.17:8000"```
+> **Note:**
+
+> - If documents need to be changed, please modify file
+templates/changes_in_mongodb.py, and refer section **update mongodb**
diff --git a/utils/test/result_collection_api/update/templates/__init__.py b/utils/test/result_collection_api/update/templates/__init__.py
new file mode 100644
index 000000000..e69de29bb
--- /dev/null
+++ b/utils/test/result_collection_api/update/templates/__init__.py
diff --git a/utils/test/result_collection_api/update/backup.py b/utils/test/result_collection_api/update/templates/backup_mongodb.py
index faa4fd410..7e0dd5545 100644
--- a/utils/test/result_collection_api/update/backup.py
+++ b/utils/test/result_collection_api/update/templates/backup_mongodb.py
@@ -6,9 +6,9 @@
# which accompanies this distribution, and is available at
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################
-import os
import argparse
import datetime
+import os
from utils import execute, main, get_abspath
diff --git a/utils/test/result_collection_api/update/changes.py b/utils/test/result_collection_api/update/templates/changes_in_mongodb.py
index b3e23803d..b3e23803d 100644
--- a/utils/test/result_collection_api/update/changes.py
+++ b/utils/test/result_collection_api/update/templates/changes_in_mongodb.py
diff --git a/utils/test/result_collection_api/update/restore.py b/utils/test/result_collection_api/update/templates/restore_mongodb.py
index c45a0e621..c45a0e621 100644
--- a/utils/test/result_collection_api/update/restore.py
+++ b/utils/test/result_collection_api/update/templates/restore_mongodb.py
diff --git a/utils/test/result_collection_api/update/templates/rm_olds.sh b/utils/test/result_collection_api/update/templates/rm_olds.sh
new file mode 100644
index 000000000..c6bca1867
--- /dev/null
+++ b/utils/test/result_collection_api/update/templates/rm_olds.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+proc_number=`ps -ef | grep opnfv-testapi | grep -v grep | wc -l`
+if [ $proc_number -gt 0 ]; then
+ procs=`ps -ef | grep opnfv-testapi | grep -v grep`
+ echo "begin to kill opnfv-testapi $procs"
+ ps -ef | grep opnfv-testapi | grep -v grep | awk '{print $2}' | xargs kill -kill &>/dev/null
+fi
+
+number=`docker ps -a | awk 'NR != 1' | grep testapi | wc -l`
+if [ $number -gt 0 ]; then
+ containers=number=`docker ps -a | awk 'NR != 1' | grep testapi`
+ echo "begin to rm containers $containers"
+ docker ps -a | awk 'NR != 1' | grep testapi | awk '{print $1}' | xargs docker rm -f &>/dev/null
+fi
diff --git a/utils/test/result_collection_api/update/update.py b/utils/test/result_collection_api/update/templates/update_mongodb.py
index 8b385a0b3..b1e378dd7 100644
--- a/utils/test/result_collection_api/update/update.py
+++ b/utils/test/result_collection_api/update/templates/update_mongodb.py
@@ -10,8 +10,8 @@ import argparse
from pymongo import MongoClient
+from changes_in_mongodb import collections_old2New, fields_old2New, docs_old2New
from utils import main, parse_mongodb_url
-from changes import collections_old2New, fields_old2New, docs_old2New
parser = argparse.ArgumentParser(description='Update MongoDBs')
diff --git a/utils/test/result_collection_api/update/utils.py b/utils/test/result_collection_api/update/templates/utils.py
index a18ff0389..a18ff0389 100644
--- a/utils/test/result_collection_api/update/utils.py
+++ b/utils/test/result_collection_api/update/templates/utils.py
diff --git a/utils/test/result_collection_api/update/update.yml b/utils/test/result_collection_api/update/update.yml
new file mode 100644
index 000000000..08839564a
--- /dev/null
+++ b/utils/test/result_collection_api/update/update.yml
@@ -0,0 +1,41 @@
+---
+- hosts: "{{ host }}"
+ remote_user: "{{ user }}"
+ become: yes
+ become_method: sudo
+ vars:
+ user: "root"
+ port: "8000"
+ update_path: "/tmp/testapi"
+ image: "opnfv/testapi"
+ mongodb_url: "mongodb://172.17.0.1:27017"
+ swagger_url: "http://{{ host }}:{{ port }}"
+ tasks:
+ - name: create temporary update directory
+ file:
+ path: "{{ update_path }}"
+ state: directory
+ - name: transfer files in templates
+ copy:
+ src: templates/
+ dest: "{{ update_path }}"
+ - name: backup mongodb database
+ command: "python {{ update_path }}/backup_mongodb.py -u {{ mongodb_url }} -o {{ update_path }}"
+ - name: stop and remove old versions
+ command: bash "{{ update_path }}/rm_olds.sh"
+ register: rm_result
+ - debug: msg="{{ rm_result.stderr }}"
+ - name: delete old docker images
+ command: docker rmi "{{ image }}"
+ ignore_errors: true
+ - name: update mongodb
+ command: "python {{ update_path }}/update_mongodb.py -u {{ mongodb_url }}"
+ - name: docker start testapi server
+ command: docker run -dti -p "{{ port }}:8000"
+ -e "mongodb_url={{ mongodb_url }}"
+ -e "swagger_url={{ swagger_url }}"
+ "{{ image }}"
+ - name: remove temporary update directory
+ file:
+ path: "{{ update_path }}"
+ state: absent \ No newline at end of file